/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.common.request;

import org.simantics.db.Resource;

abstract public class ResourceAsyncMultiRead2<T> extends ResourceAsyncMultiRead<T> {

    final protected Resource resource2;

    @Override
    public int hashCode() {
        return resource.hashCode() ^ resource2.hashCode();
    }

    @Override
    public boolean equals(Object object) {
        if (this == object)
            return true;
        else if (object == null)
            return false;
        else if (getClass() != object.getClass())
            return false;
        ResourceAsyncMultiRead2<?> r = (ResourceAsyncMultiRead2<?>)object;
        return resource.equals(r.resource) && resource2.equals(r.resource2);
    }

    public ResourceAsyncMultiRead2(Resource resource, Resource predicate) {
        super(resource);
        this.resource2 = predicate;
    }

}
